<?php
include 'class-wp-tvs-postype.php';
include 'class-wp-schedule-postype.php';
include 'shortcode-builder.php';

add_action( 'admin_enqueue_scripts', 'extvs_admin_scripts' );
function extvs_admin_scripts(){
	$js_params = array( 'ajaxurl' => admin_url( 'admin-ajax.php' ) );
	wp_localize_script( 'jquery', 'extvs_ajax', $js_params  );
	wp_enqueue_style('extvs-admin-style', EXTVS_PATH . 'admin/css/style.css','','1.0');
	wp_enqueue_script('extvs-admin-js', EXTVS_PATH . 'admin/js/admin.js', array( 'jquery' ),'1.0' );
}

add_action( 'wp_ajax_extvs_admin_add_program', 'extvs_admin_add_program' );
function extvs_admin_add_program(){
	$program_id = $_POST['program_id'];
	if($program_id > 0){
		$name = $content = $subtitle = $image = $image_id = '';
		$name = get_the_title( $program_id );
		$args = array('p' => $program_id, 'post_type' => 'extvs_programme');
	    $loop = new WP_Query($args);

	    while ( $loop->have_posts() ) : $loop->the_post();
	        $content = get_the_content();
	        $subtitle = get_post_meta( get_the_ID(), 'extv_pro_subtitle', true );
	        if (has_post_thumbnail()) {
	        	$image = get_the_post_thumbnail_url(get_the_ID(),'full');
	        	$image_id = get_post_thumbnail_id( get_the_ID() );;
	        }
	    endwhile;
		$output =  array('name'=>$name,'content'=>$content,'subtitle'=>$subtitle, 'image'=>$image, 'image_id'=>$image_id);
		echo str_replace('\/', '/', json_encode($output));
	}
	exit;
}
add_filter( 'manage_extvs_scbd_posts_columns', 'extvs_edit_scbd_columns',99 );

function extvs_edit_scbd_columns( $columns ) {
	unset($columns['date']);
	$columns['layout'] = esc_html__( 'Type' , 'tv-schedule' );
	$columns['shortcode'] = esc_html__( 'Shortcode' , 'tv-schedule' );
	$columns['date'] = esc_html__( 'Publish date' , 'tv-schedule' );		
	return $columns;
}
add_action( 'manage_extvs_scbd_posts_custom_column', 'extvs_scbd_custom_columns',12);
function extvs_scbd_custom_columns( $column ) {
	global $post;
	switch ( $column ) {
		case 'layout':
			$sc_type = get_post_meta($post->ID, 'sc_type', true);
			echo '<span class="layout">'.wp_kses_post($sc_type).'</span>';
			break;
		case 'shortcode':
			$_shortcode = get_post_meta($post->ID, 'tvs_shortcode', true);
			echo '<input type="text" readonly name="tvs_shortcode" value="'.esc_attr($_shortcode).'">';
			break;	
	}
}
