<?php
class extvs_SC_Builder {
	public function __construct(){
        add_action( 'init', array( $this, 'register_post_type' ) );
		add_action( 'cmb2_admin_init', array($this,'register_metabox2') );
		add_action( 'save_post', array($this,'save_shortcode'),1 );
		add_shortcode( 'extvssc', array($this,'run_extvssc') );
    }
	function run_extvssc($atts, $content){
		$id = isset($atts['id']) ? $atts['id'] : '';
		$sc = get_post_meta( $id, '_tvssc', true );
		if($id=='' || $sc==''){ return;}
		return do_shortcode($sc);
	}
	function save_shortcode($post_id){
		if('extvs_scbd' != get_post_type()){ return;}
		if(isset($_POST['sc_type'])){
			$style = isset($_POST['style']) ? $_POST['style'] : 1;
			$fullcontent_in = isset($_POST['fullcontent_in']) ? $_POST['fullcontent_in'] : 'collapse';
			$show_image = isset($_POST['show_image']) ? $_POST['show_image'] : 'show';
			$channel = isset($_POST['channel']) ? $_POST['channel'] : '';
			$channel_display = isset($_POST['channel_display']) ? $_POST['channel_display'] : 'all';
			$slidesshow = isset($_POST['slidesshow']) ? $_POST['slidesshow'] : '7';
			$slidesscroll = isset($_POST['slidesscroll']) ? $_POST['slidesscroll'] : '3';
			$start_on = isset($_POST['start_on']) ? $_POST['start_on'] : '5';
			$before_today = isset($_POST['before_today']) ? $_POST['before_today'] : '5';
			$after_today = isset($_POST['after_today']) ? $_POST['after_today'] : '15';

			$order = isset($_POST['order']) ? $_POST['order'] : '';
			$orderby = isset($_POST['orderby']) ? $_POST['orderby'] : '';
			$meta_key = isset($_POST['meta_key']) ? $_POST['meta_key'] : '';
			$meta_value = isset($_POST['meta_value']) ? $_POST['meta_value'] : '';

			if($_POST['sc_type'] == 'simple'){
				
				$sc = '[ex_tvs_simple style="'.esc_attr($style).'" fullcontent_in="'.esc_attr($fullcontent_in).'" show_image="'.esc_attr($show_image).'" channel="'.esc_attr($channel).'" slidesshow="'.esc_attr($slidesshow).'" slidesscroll="'.esc_attr($slidesscroll).'" start_on="'.esc_attr($start_on).'" before_today="'.esc_attr($before_today).'" after_today="'.esc_attr($after_today).'" order="'.esc_attr($order).'" orderby="'.esc_attr($orderby).'" meta_key="'.esc_attr($meta_key).'" meta_value="'.esc_attr($meta_value).'"]';
				
			}else{
				
				$sc = '[ex_tvs_advance style="'.esc_attr($style).'" fullcontent_in="'.esc_attr($fullcontent_in).'" show_image="'.esc_attr($show_image).'" channel="'.esc_attr($channel).'" channel_display="'.esc_attr($channel_display).'" slidesshow="'.esc_attr($slidesshow).'" slidesscroll="'.esc_attr($slidesscroll).'" start_on="'.esc_attr($start_on).'" before_today="'.esc_attr($before_today).'" after_today="'.esc_attr($after_today).'" order="'.esc_attr($order).'" orderby="'.esc_attr($orderby).'" meta_key="'.esc_attr($meta_key).'" meta_value="'.esc_attr($meta_value).'"]';
				
			}
			if($sc!=''){
				update_post_meta( $post_id, '_tvssc', $sc );
			}
			update_post_meta( $post_id, 'tvs_shortcode', '[extvssc id="'.$post_id.'"]' );
		}
	}
	function register_post_type(){
		$labels = array(
			'name'               => esc_html__('Shortcodes','tv-schedule'),
			'singular_name'      => esc_html__('Shortcodes','tv-schedule'),
			'add_new'            => esc_html__('Add New Shortcodes','tv-schedule'),
			'add_new_item'       => esc_html__('Add New Shortcodes','tv-schedule'),
			'edit_item'          => esc_html__('Edit Shortcodes','tv-schedule'),
			'new_item'           => esc_html__('New Shortcode','tv-schedule'),
			'all_items'          => esc_html__('Shortcodes builder','tv-schedule'),
			'view_item'          => esc_html__('View Shortcodes','tv-schedule'),
			'search_items'       => esc_html__('Search Shortcodes','tv-schedule'),
			'not_found'          => esc_html__('No Shortcode found','tv-schedule'),
			'not_found_in_trash' => esc_html__('No Shortcode found in Trash','tv-schedule'),
			'parent_item_colon'  => '',
			'menu_name'          => esc_html__('Shortcodes','tv-schedule')
		);
		$rewrite = false;
		$args = array(  
			'labels' => $labels,  
			'menu_position' => 8, 
			'supports' => array('title','custom-fields'),
			'public'             => false,
			'publicly_queryable' => true,
			'show_ui'            => true,
			'show_in_menu'       => 'edit.php?post_type=extvs_schedule',
			'menu_icon' =>  'dashicons-editor-ul',
			'query_var'          => true,
			'capability_type'    => 'post',
			'has_archive'        => true,
			'hierarchical'       => false,
			'menu_position'      => null,
			'rewrite' => $rewrite,
		);  
		register_post_type('extvs_scbd',$args);  
	}
	
	function register_metabox2() {
		/**
		 * Sample metabox to demonstrate each field type included
		 */
		$layout = new_cmb2_box( array(
			'id'            => 'sc_tvs_shortcode',
			'title'         => esc_html__( 'Shortcode type', 'tv-schedule' ),
			'object_types'  => array( 'extvs_scbd' ), // Post type
		) );
	
		$layout->add_field( array(
			'name'             => esc_html__( 'Type', 'tv-schedule' ),
			'desc'             => esc_html__( 'Select type of shortcode', 'tv-schedule' ),
			'id'               => 'sc_type',
			'type'             => 'select',
			'show_option_none' => false,
			'default'          => 'simple',
			'options'          => array(
				'simple' => esc_html__( 'Simple schedule', 'tv-schedule' ),
				'advance'   => esc_html__( 'Advance schedule', 'tv-schedule' ),
			),
		) );
		if(isset($_GET['post']) && is_numeric($_GET['post'])){
			$layout->add_field( array(
				'name'       => esc_html__( 'Shortcode', 'tv-schedule' ),
				'desc'       => esc_html__( 'Copy this shortcode and paste it into your post, page, or text widget content:', 'tv-schedule' ),
				'id'         => 'tvs_shortcode',
				'type'       => 'text',
				'classes'             => '',
				'attributes'  => array(
					'readonly' => 'readonly',
				),
			) );
		}
		$sc_option = new_cmb2_box( array(
			'id'            => 'sc_tvs_option',
			'title'         => esc_html__( 'Shortcode Option', 'tv-schedule' ),
			'object_types'  => array( 'extvs_scbd' ),
		) );
		
		$sc_option->add_field( array(
			'name'             => esc_html__( 'Style', 'tv-schedule' ),
			'desc'             => esc_html__( 'Select style of shortcode', 'tv-schedule' ),
			'id'               => 'style',
			'type'             => 'select',
			'classes'             => 'column-2',
			'show_option_none' => false,
			'default'          => '1',
			'options'          => array(
				'1' => esc_html__('1', 'tv-schedule'),
				'2' => esc_html__('2', 'tv-schedule'),
				'3' => esc_html__('3', 'tv-schedule'),
			),
		) );
		
		$sc_option->add_field( array(
			'name'             => esc_html__( 'Full content', 'tv-schedule' ),
			'desc'             => esc_html__( 'Select type of Full content', 'tv-schedule' ),
			'id'               => 'fullcontent_in',
			'type'             => 'select',
			'classes'             => 'column-2',
			'show_option_none' => false,
			'default'          => 'collapse',
			'options'          => array(
				'collapse' => esc_html__( 'Collapse', 'tv-schedule' ),
				'modal'   => esc_html__( 'Modal', 'tv-schedule' ),
				'tooltip'   => esc_html__( 'Tooltip', 'tv-schedule' ),
				'none'   => esc_html__( 'None', 'tv-schedule' ),
			),
		) );
		$sc_option->add_field( array(
			'name'       => esc_html__( 'Show image', 'tv-schedule' ),
			'desc'       => esc_html__( 'Select Show image', 'tv-schedule' ),
			'id'         => 'show_image',
			'type'       => 'select',
			'classes'             => 'column-2',
			'show_option_none' => false,
			'default'          => 'collapse',
			'options'          => array(
				'show' => esc_html__( 'Show', 'tv-schedule' ),
				'none'   => esc_html__( 'None', 'tv-schedule' ),
			),
		) );
		$sc_option->add_field( array(
			'name'       => esc_html__( 'Channel', 'tv-schedule' ),
			'desc'       => esc_html__( 'Input channel', 'tv-schedule' ),
			'id'         => 'channel',
			'type'       => 'text',
			'classes'             => 'column-2',
		) );
		$sc_option->add_field( array(
			'name'       => esc_html__( 'Channel Display', 'tv-schedule' ),
			'desc'       => esc_html__( 'Select type to show channel', 'tv-schedule' ),
			'id'         => 'channel_display',
			'type'       => 'select',
			'classes'             => 'column-2 ex-hide-simple',
			'show_option_none' => false,
			'default'          => 'all',
			'options'          => array(
				'all' => esc_html__( 'All(name and image)', 'tv-schedule' ),
				'image-only'   => esc_html__( 'Image only', 'tv-schedule' ),
				'name-only'   => esc_html__( 'Name only', 'tv-schedule' ),
			),
		) );
		$sc_option->add_field( array(
			'name'       => esc_html__( 'Number item visible', 'tv-schedule' ),
			'desc'       => esc_html__( 'Number of slides to show at a time', 'tv-schedule' ),
			'id'         => 'slidesshow',
			'type'       => 'text',
			'classes'             => 'column-2 ex-hide-slider',
		) );
		$sc_option->add_field( array(
			'name'       => esc_html__( 'Number slides to scroll', 'tv-schedule' ),
			'desc'       => esc_html__( 'Number of slides to scroll at a time', 'tv-schedule' ),
			'id'         => 'slidesscroll',
			'type'       => 'text',
			'classes'             => 'column-2 ex-hide-slider',
		) );
		$sc_option->add_field( array(
			'name'       => esc_html__( 'Start slides on item', 'tv-schedule' ),
			'desc'       => esc_html__( 'Number of items to start', 'tv-schedule' ),
			'id'         => 'start_on',
			'type'       => 'text',
			'classes'             => 'column-2 ex-hide-slider',
		) );
		$sc_option->add_field( array(
			'name'       => esc_html__( 'Number of date before today to show', 'tv-schedule' ),
			'desc'       => esc_html__( 'Enter Number, ex: 3', 'tv-schedule' ),
			'id'         => 'before_today',
			'type'       => 'text',
			'classes'             => 'column-2 ex-hide-slider',
		) );
		$sc_option->add_field( array(
			'name'       => esc_html__( 'Number of date after today to show', 'tv-schedule' ),
			'desc'       => esc_html__( 'Enter Number, ex: 7', 'tv-schedule' ),
			'id'         => 'after_today',
			'type'       => 'text',
			'classes'             => 'column-2 ex-hide-slider',
		) );

		$sc_option->add_field( array(
			'name'       => esc_html__( 'Order', 'tv-schedule' ),
			'desc'       => '',
			'id'         => 'order',
			'type'             => 'select',
			'classes'             => 'column-2',
			'show_option_none' => false,
			'default'          => '',
			'options'          => array(
				'DESC' => esc_html__('DESC', 'tv-schedule'),
				'ASC'   => esc_html__('ASC', 'tv-schedule'),
			),
		) );
		$sc_option->add_field( array(
			'name'       => esc_html__( 'Order by', 'tv-schedule' ),
			'desc'       => '',
			'id'         => 'orderby',
			'type'             => 'select',
			'classes'             => 'column-2',
			'show_option_none' => false,
			'default'          => '',
			'options'          => array(
				'date' => esc_html__('Date', 'tv-schedule'),
				'ID'   => esc_html__('ID', 'tv-schedule'),
				'author' => esc_html__('Author', 'tv-schedule'),
				'title'   => esc_html__('Title', 'tv-schedule'),
				'name' => esc_html__('Name', 'tv-schedule'),
				'modified'   => esc_html__('Modified', 'tv-schedule'),
				'parent' => esc_html__('Parent', 'tv-schedule'),
				'rand'   => esc_html__('Rand', 'tv-schedule'),
				'menu_order' => esc_html__('Menu order', 'tv-schedule'),
				'meta_value'   => esc_html__('Meta value', 'tv-schedule'),
				'meta_value_num' => esc_html__('Meta value num', 'tv-schedule'),
				'post__in'   => esc_html__('Post__in', 'tv-schedule'),
				'None'   => esc_html__('None', 'tv-schedule'),
			),
		) );
		$sc_option->add_field( array(
			'name'       => esc_html__( 'Meta key', 'tv-schedule' ),
			'desc'       => esc_html__( 'Enter meta key to query', 'tv-schedule' ),
			'id'         => 'meta_key',
			'type'       => 'text',
			'classes'             => 'column-2',
		) );
		$sc_option->add_field( array(
			'name'       => esc_html__( 'Meta value', 'tv-schedule' ),
			'desc'       => esc_html__( 'Enter meta value to query', 'tv-schedule' ),
			'id'         => 'meta_value',
			'type'       => 'text',
			'classes'             => 'column-2',
		) );
		
	
	}
	
}
$extvs_SC_Builder = new extvs_SC_Builder();