<?php
/**
 * Include and setup custom metaboxes and fields. (make sure you copy this file to outside the CMB2 directory)
 *
 * Be sure to replace all instances of 'yourprefix_' with your project's prefix.
 * http://nacin.com/2010/05/11/in-wordpress-prefix-everything/
 *
 * @category YourThemeOrPlugin
 * @package  Demo_CMB2
 * @license  http://www.opensource.org/licenses/gpl-license.php GPL v2.0 (or later)
 * @link     https://github.com/CMB2/CMB2
 */

/**
 * Get the bootstrap! If using the plugin from wordpress.org, REMOVE THIS!
 */

if ( file_exists( dirname( __FILE__ ) . '/cmb2/init.php' ) ) {
	require_once dirname( __FILE__ ) . '/cmb2/init.php';
} elseif ( file_exists( dirname( __FILE__ ) . '/CMB2/init.php' ) ) {
	require_once dirname( __FILE__ ) . '/CMB2/init.php';
}

require_once dirname( __FILE__ ) . '/Post-Search-field/cmb2_post_search_field.php';

// version 2.0 add_action( 'cmb2_admin_init', 'extvs_register_pro_metabox' );
/**
 * Hook in and add a demo metabox. Can only happen on the 'cmb2_admin_init' or 'cmb2_init' hook.
 */
function extvs_get_option( $key = '', $tab=false, $default = false ) {
	if(isset($tab) && $tab!=''){
		$option_key = $tab;
	}else{
		$option_key = 'extvs_options';
	}
	if ( function_exists( 'cmb2_get_option' ) ) {
		// Use cmb2_get_option as it passes through some key filters.
		return cmb2_get_option( $option_key, $key, $default );
	}
	// Fallback to get_option if CMB2 is not loaded yet.
	$opts = get_option( $option_key, $default );
	$val = $default;
	if ( 'all' == $key ) {
		$val = $opts;
	} elseif ( is_array( $opts ) && array_key_exists( $key, $opts ) && false !== $opts[ $key ] ) {
		$val = $opts[ $key ];
	}
	return $val;
}



function extvs_register_pro_metabox() {
	$prefix = 'extvsch_';

	/**
	 * Food general info
	 */
	$team_info = new_cmb2_box( array(
		'id'            => $prefix . 'metabox',
		'title'         => esc_html__( 'Programme info', 'tv-schedule' ),
		'object_types'  => array( 'extvs_programme' ), // Post type
	) );
	$team_info->add_field( array(
		'name'           => 'Programme Type',
		'desc'           => 'Select Programme Type',
		'id'             => $prefix. '_category_select',
		'taxonomy'       => 'extvs_category', //Enter Taxonomy Slug
		'type'           => 'taxonomy_select',
		'remove_default' => 'true', // Removes the default metabox provided by WP core.
		// Optionally override the args sent to the WordPress get_terms function.
		'query_args' => array(
			// 'orderby' => 'slug',
			// 'hide_empty' => true,
		),
	) );
}

//add_action( 'cmb2_admin_init', 'extvs_register_taxonomy_metabox' );
function extvs_register_taxonomy_metabox() {
	$prefix = 'extvs_category_';
	/**
	 * Metabox to add fields to categories and tags
	 */
	$cmb_term = new_cmb2_box( array(
		'id'               => $prefix . 'data',
		'title'            => esc_html__( 'Category Metabox', 'tv-schedule' ), // Doesn't output for term boxes
		'object_types'     => array( 'term' ), // Tells CMB2 to use term_meta vs post_meta
		'taxonomies'       => array( 'extvs_channel'), // Tells CMB2 which taxonomies should have these fields
		'new_term_section' => true, // Will display in the "Add New Category" section
	) );
	$cmb_term->add_field( array(
		'name' => esc_html__( 'Chanel Icon', 'tv-schedule' ),
		'desc' => esc_html__( 'Set icon image for Chanel', 'tv-schedule' ),
		'id'   => $prefix . 'icon',
		'type' => 'file',
		'options' => array(
			'url' => false, // Hide the text input for the url
		),
		'query_args' => array(
			'type' => array(
				'image/gif',
				'image/jpeg',
				'image/png',
				'image/svg',
			),
		),
		'preview_size' => 'medium',
		'text'    => array(
			'add_upload_file_text' => esc_html__( 'Select Image', 'tv-schedule' ),
		),
	) );
}

function extvs_filter_schedule_by_taxonomies( $post_type, $which ) {

	// Apply this only on a specific post type
	if ( 'extvs_schedule' !== $post_type )
		return;

	// A list of taxonomy slugs to filter by
	$taxonomies = array( 'extvs_channel');

	foreach ( $taxonomies as $taxonomy_slug ) {

		// Retrieve taxonomy data
		$taxonomy_obj = get_taxonomy( $taxonomy_slug );
		$taxonomy_name = $taxonomy_obj->labels->name;

		// Retrieve taxonomy terms
		$terms = get_terms( $taxonomy_slug,'hide_empty=0');

		// Display filter HTML
		echo "<select name='{$taxonomy_slug}' id='{$taxonomy_slug}' class='postform'>";
		echo '<option value="">' . sprintf( esc_html__( 'Show All %s', 'tv-schedule' ), $taxonomy_name ) . '</option>';
		foreach ( $terms as $term ) {
			printf(
				'<option value="%1$s" %2$s>%3$s</option>',
				$term->slug,
				( ( isset( $_GET[$taxonomy_slug] ) && ( $_GET[$taxonomy_slug] == $term->slug ) ) ? ' selected="selected"' : '' ),
				$term->name
			);
		}
		echo '</select>';
	}

}
add_action( 'restrict_manage_posts', 'extvs_filter_schedule_by_taxonomies' , 10, 2);

add_action( 'restrict_manage_posts', 'extvs_filter_schedule_by_date' );
function extvs_filter_schedule_by_date(){
    $type = 'post';
    if (isset($_GET['post_type'])) {
        $type = $_GET['post_type'];
    }

    //only add filter to post type you want
    if ('extvs_schedule' == $type){
    	$current_v = isset($_GET['extvs_date_filter'])? $_GET['extvs_date_filter']:'';
    	wp_enqueue_style( 'bootstrap-datepicker', EXTVS_PATH . 'admin/js/jquery-timepicker/bootstrap-datepicker.css');
		wp_enqueue_script( 'bootstrap-datepicker', EXTVS_PATH . 'admin/js/jquery-timepicker/bootstrap-datepicker.js', array( 'jquery' ) );
        ?>
        <input type="text" id="extvs_date_filter" name="extvs_date_filter" value="<?php echo esc_attr($current_v) ?>">
        <?php
    }
}


add_filter( 'parse_query', 'extvs_filter_schedule_by_date_query' );

function extvs_filter_schedule_by_date_query( $query ){
    global $pagenow;
    $type = 'post';
    if (isset($_GET['post_type'])) {
        $type = $_GET['post_type'];
    }
    if ( 'extvs_schedule' == $type && is_admin() && $pagenow=='edit.php' && isset($_GET['extvs_date_filter']) && $_GET['extvs_date_filter'] != '') {
    	$date = str_replace('/', '-', $_GET['extvs_date_filter']);
		$date = strtotime($date);
        $query->query_vars['meta_key'] = 'extvs_schedule_date';
        $query->query_vars['meta_value'] = $date;
    }
}

// Setting option
function extvs_register_setting_options() {
	/**
	 * Registers main options page menu item and form.
	 */
	$args = array(
		'id'           => 'extvs_options_page',
		'title'        => esc_html__('Settings','tv-schedule'),
		'object_types' => array( 'options-page' ),
		'option_key'   => 'extvs_options',
		'parent_slug'  => 'edit.php?post_type=extvs_schedule',
		'tab_group'    => 'extvs_options',
		'tab_title'    => esc_html__('General','tv-schedule'),
		'message_cb'      => 'exfood_options_page_message_',
	);
	// 'tab_group' property is supported in > 2.4.0.
	if ( version_compare( CMB2_VERSION, '2.4.0' ) ) {
		$args['display_cb'] = 'extvs_options_display_with_tabs';
	}
	$main_options = new_cmb2_box( $args );
	/**
	 * Options fields ids only need
	 * to be unique within this box.
	 * Prefix is not needed.
	 */
	$main_options->add_field( array(
		'name'    => esc_html__('Main Color','tv-schedule'),
		'desc'    => esc_html__('Choose Main Color for plugin','tv-schedule'),
		'id'      => 'extvs_color',
		'type'    => 'colorpicker',
		'default' => '',
	) );
	$main_options->add_field( array(
		'name'       => esc_html__( 'Content Font Family', 'tv-schedule' ),
		'desc'       => esc_html__('Enter Google font-family name . For example, if you choose "Source Sans Pro" Google Font, enter Source Sans Pro','tv-schedule'),
		'id'         => 'extvs_font_family',
		'type'       => 'text',
		'default' => '',
	) );
	$main_options->add_field( array(
		'name'       => esc_html__( 'Content Font Size', 'tv-schedule' ),
		'desc'       => esc_html__('Enter size of main font, default:13px, Ex: 14px','tv-schedule'),
		'id'         => 'extvs_font_size',
		'type'       => 'text',
		'default' => '',
	) );
	$main_options->add_field( array(
		'name'    => esc_html__('Content Font Color','tv-schedule'),
		'desc'    => esc_html__('Choose Content Font Color for plugin','tv-schedule'),
		'id'      => 'extvs_ctcolor',
		'type'    => 'colorpicker',
		'default' => '',
	) );
	$main_options->add_field( array(
		'name'       => esc_html__( 'Heading Font Family', 'tv-schedule' ),
		'desc'       => esc_html__('Enter Google font-family name. For example, if you choose "Oswald" Google Font, enter Oswald','tv-schedule'),
		'id'         => 'extvs_headingfont_family',
		'type'       => 'text',
		'default' => '',
	) );
	$main_options->add_field( array(
		'name'       => esc_html__( 'Heading Font Size', 'tv-schedule' ),
		'desc'       => esc_html__('Enter size of heading font, default: 16px, Ex: 22px','tv-schedule'),
		'id'         => 'extvs_headingfont_size',
		'type'       => 'text',
		'default' => '',
	) );
	$main_options->add_field( array(
		'name'    => esc_html__('Heading Font Color','tv-schedule'),
		'desc'    => esc_html__('Choose Heading Font Color for plugin','tv-schedule'),
		'id'      => 'extvs_hdcolor',
		'type'    => 'colorpicker',
		'default' => '',
	) );
	
	$main_options->add_field( array(
		'name'             => esc_html__( 'RTL mode', 'tv-schedule' ),
		'desc'             => esc_html__( 'Enable RTL mode for RTL language', 'tv-schedule' ),
		'id'               => 'extvs_enable_rtl',
		'type'             => 'select',
		'show_option_none' => false,
		'default' => '',
		'options'          => array(
			'' => esc_html__( 'No', 'tv-schedule' ),
			'yes'   => esc_html__( 'Yes', 'tv-schedule' ),
		),
	) );
	
	
	/**
	 * Registers secondary options page, and set main item as parent.
	 */
	$args = array(
		'id'           => 'extvs_custom_code',
		'menu_title'   => '',
		'object_types' => array( 'options-page' ),
		'option_key'   => 'extvs_custom_code_options',
		'parent_slug'  => 'edit.php?post_type=extvs_programme',
		'tab_group'    => 'extvs_options',
		'tab_title'    => esc_html__('Custom Code','tv-schedule'),
	);
	// 'tab_group' property is supported in > 2.4.0.
	if ( version_compare( CMB2_VERSION, '2.4.0' ) ) {
		$args['display_cb'] = 'extvs_options_display_with_tabs';
	}
	$customcode_options = new_cmb2_box( $args );
	$customcode_options->add_field( array(
		'name' => esc_html__('Custom Css','tv-schedule'),
		'desc' => esc_html__('Paste your custom Css code','tv-schedule'),
		'id'   => 'extvs_custom_css',
		'type' => 'textarea_code',
	) );
	$customcode_options->add_field( array(
		'name' => esc_html__('Custom Js','tv-schedule'),
		'desc' => esc_html__('Paste your custom Js code','tv-schedule'),
		'id'   => 'extvs_custom_js',
		'type' => 'textarea_code',
	) );
}

add_action( 'cmb2_admin_init', 'extvs_register_setting_options' );

/**
 * A CMB2 options-page display callback override which adds tab navigation among
 * CMB2 options pages which share this same display callback.
 *
 * @param CMB2_Options_Hookup $cmb_options The CMB2_Options_Hookup object.
 */
function extvs_options_display_with_tabs( $cmb_options ) {
	$tabs = extvs_options_page_tabs( $cmb_options );
	?>
	<div class="wrap cmb2-options-page option-<?php echo esc_attr($cmb_options->option_key); ?>">
		<?php if ( get_admin_page_title() ) : ?>
			<h2><?php echo wp_kses_post( get_admin_page_title() ); ?></h2>
		<?php endif; ?>
		<h2 class="nav-tab-wrapper">
			<?php foreach ( $tabs as $option_key => $tab_title ) : ?>
				<a class="nav-tab<?php if ( isset( $_GET['page'] ) && $option_key === $_GET['page'] ) : ?> nav-tab-active<?php endif; ?>" href="<?php menu_page_url( $option_key ); ?>"><?php echo wp_kses_post( $tab_title ); ?></a>
			<?php endforeach; ?>
		</h2>
		<form class="cmb-form" action="<?php echo esc_url( admin_url( 'admin-post.php' ) ); ?>" method="POST" id="<?php echo esc_attr($cmb_options->cmb->cmb_id); ?>" enctype="multipart/form-data" encoding="multipart/form-data">
			<input type="hidden" name="action" value="<?php echo esc_attr( $cmb_options->option_key ); ?>">
			<?php $cmb_options->options_page_metabox(); ?>
			<?php submit_button( esc_attr( $cmb_options->cmb->prop( 'save_button' ) ), 'primary', 'submit-cmb' ); ?>
		</form>
	</div>
	<?php
}
/**
 * Gets navigation tabs array for CMB2 options pages which share the given
 * display_cb param.
 *
 * @param CMB2_Options_Hookup $cmb_options The CMB2_Options_Hookup object.
 *
 * @return array Array of tab information.
 */
function extvs_options_page_tabs( $cmb_options ) {
	$tab_group = $cmb_options->cmb->prop( 'tab_group' );
	$tabs      = array();
	foreach ( CMB2_Boxes::get_all() as $cmb_id => $cmb ) {
		if ( $tab_group === $cmb->prop( 'tab_group' ) ) {
			$tabs[ $cmb->options_page_keys()[0] ] = $cmb->prop( 'tab_title' )
				? $cmb->prop( 'tab_title' )
				: $cmb->prop( 'title' );
		}
	}
	return $tabs;
}