<?php
function extvs_custom_css(){
    ob_start();
    $extvs_color = extvs_get_option('extvs_color');

    $hex  = str_replace("#", "", $extvs_color);
    if(strlen($hex) == 3) {
      $r = hexdec(substr($hex,0,1).substr($hex,0,1));
      $g = hexdec(substr($hex,1,1).substr($hex,1,1));
      $b = hexdec(substr($hex,2,1).substr($hex,2,1));
    } else {
      $r = hexdec(substr($hex,0,2));
      $g = hexdec(substr($hex,2,2));
      $b = hexdec(substr($hex,4,2));
    }
    $rgb = $r.','. $g.','.$b;
    if($extvs_color!=''){
    	?>

        .ex-tvs-simple.style-1 .extvs-dropdown,
        .ex-tvs-simple.style-1 .ex-date-list-parent,
        .ex-date-list-out,
        .ex-tvs-simple.style-3 .ex-date-list-parent,
        .ex-tvs-simple.style-3 .extvs-style3-chanel ul li:hover,
        .ex-tvs-simple.style-3 .extvs-style3-chanel ul li.extvs-inline-at,
        .ex-chanel-list .extvs-inline-chanel,
        .ex-tvs-simple.style-2 .ex-date-list .extvs-date-day,
        .ex-tvs-simple.style-1 .ex-parent-simple table thead th,
        .extvs-advance-date,
        .extvs-advance-chanel ul li,
        .extvs-advance-detail .extvs-advance-timeline ul li,
        .ex-tvs-advance.style-3 .extvs-addate-parent,
        .extvs_modal .tvs-modal-content .tvs_modal_des .md-date,
        .ex-tvs-advance.style-2 .ex-date-list-parent{background:<?php echo esc_attr($extvs_color);?>;}
        .ex-tvs-simple[id^=ex-] .ex-parent-simple table tbody tr.extvs-cr-progr,
        .item-tvs.extvs-cr-progr,
        .extvs-advance-program ul li .extvs-pro-width.extvs-cr-progr{background: rgba(<?php echo esc_attr($rgb);?>, .1);}
        .ex-tvs-simple.style-3 .extvs-style3-chanel ul li:last-child{
            border-color:<?php echo esc_attr($extvs_color);?>;
        }
        

        .ex-tvs-simple.style-3 .extvs-style3-chanel ul li
        {
            color:<?php echo esc_attr($extvs_color);?>;
            border-color:<?php echo esc_attr($extvs_color);?>;
        }

        .ex-tvs-simple.style-1 .ex-date-list-parent .extvs-prev-bt,
        .ex-tvs-simple.style-2 .ex-date-list-parent .extvs-prev-bt,
        .ex-tvs-simple.style-3 .ex-date-list-parent .extvs-prev-bt,
        .ex-tvs-advance.style-2 .ex-date-list-parent .extvs-prev-bt{
            background: linear-gradient(to left,rgba(255,255,255,0),<?php echo esc_attr($extvs_color);?> 40%);
        }
        .ex-tvs-simple.style-1 .ex-date-list-parent .extvs-next-bt,
        .ex-tvs-simple.style-2 .ex-date-list-parent .extvs-next-bt,
        .ex-tvs-simple.style-3 .ex-date-list-parent .extvs-next-bt,
        .ex-tvs-advance.style-2 .ex-date-list-parent .extvs-next-bt{
            background: linear-gradient(to right,rgba(255,255,255,0),<?php echo esc_attr($extvs_color);?> 40%);
        }

        
        <?php
    }
    
    $extvs_font_family = extvs_get_option('extvs_font_family');
    $main_font_family = explode(":", $extvs_font_family);
    $main_font_family = $main_font_family[0];
    if($extvs_font_family!=''){?>
        .ex-tvs-simple,
        .extvs-qtip,
        .ex-tvs-advance{font-family: "<?php echo esc_html($main_font_family);?>", sans-serif;}
        <?php
    }
    $extvs_font_size = extvs_get_option('extvs_font_size');
    if($extvs_font_size!=''){?>
        .ex-tvs-simple,
        .ex-tvs-advance,
        .extvs-qtip.qtip,
        .ex-tvs-advance span.sub-tt,
        span.sub-tt,
        .ex-tvs-simple .ex-parent-simple span.sub-tt{font-size: <?php echo esc_html($extvs_font_size);?>;}
        <?php
    }
    $extvs_ctcolor = extvs_get_option('extvs_ctcolor');
    if($extvs_ctcolor!=''){?>
        .ex-tvs-simple,
        .extvs-qtip.qtip,
        .ex-tvs-advance{color: <?php echo esc_html($extvs_ctcolor);?>;}
        <?php
    }

    $extvs_headingfont_family = extvs_get_option('extvs_headingfont_family');
    $h_font_family = explode(":", $extvs_headingfont_family);
    $h_font_family = $h_font_family[0];
     if($h_font_family!=''){?>
        .ex-chanel-list,
        .ex-date-list-parent,
        .extvs-modal h3,
        .extvs-qtip h3,
        .ex-parent-simple .item-tvs h3,
        .extvs-advance-chanel .extvs-chanel-name,
        .ex-tvs-advance.style-3 .extvs-ad-list-week .extvs-date-adweek,
        .ex-tvs-simple.style-3 .extvs-style3-chanel ul li{
            font-family: "<?php echo esc_html($h_font_family);?>", sans-serif;
        }
        <?php 
    }
    $extvs_headingfont_size = extvs_get_option('extvs_headingfont_size');
    if($extvs_headingfont_size!=''){?>
        .ex-chanel-list,
        .ex-date-list-parent,
        .extvs-modal h3,
        .extvs-qtip h3,
        .ex-parent-simple .item-tvs h3,
        .extvs-advance-chanel .extvs-chanel-name,
        .ex-tvs-advance.style-3 .extvs-ad-list-week .extvs-date-adweek,
        .ex-tvs-simple.style-3 .extvs-style3-chanel ul li,
        .ex-date-list .extvs-date-day{font-size: <?php echo esc_html($extvs_headingfont_size);?>;}
        <?php
    }
    $extvs_hdcolor = extvs_get_option('extvs_hdcolor');
    if($extvs_hdcolor!=''){?>
        .extvs-qtip h3,
        .ex-parent-simple .item-tvs h3{color: <?php echo esc_html($extvs_hdcolor);?>;}
        <?php
    }

    $extvs_custom_css = extvs_get_option('extvs_custom_css','extvs_custom_code_options');
    if($extvs_custom_css!=''){
     	echo wp_kses_post($extvs_custom_css);
    }
    $output_string = ob_get_contents();
    ob_end_clean();
    return $output_string;
}