<?php
//shortcode

//widget
include plugin_dir_path(__FILE__).'widgets/pb-list-shortcode.php';
include plugin_dir_path(__FILE__).'shortcodes/wp-tvs-simple.php';
include plugin_dir_path(__FILE__).'shortcodes/wp-tvs-advance.php';

if(!function_exists('extvs_template_plugin')){
	function extvs_template_plugin($pageName,$shortcode=false){
		if(isset($shortcode) && $shortcode== true){
			if (locate_template('tv-schedule/content-shortcodes/content-' . $pageName . '.php') != '') {
				get_template_part('tv-schedule/content-shortcodes/content', $pageName);
			} else {
				include extvs_get_plugin_url().'templates/content-shortcodes/content-' . $pageName . '.php';
			}
		}else{
			if (locate_template('tv-schedule/' . $pageName . '.php') != '') {
				get_template_part('tv-schedule/', $pageName);
			} else {
				include extvs_get_plugin_url().'templates/' . $pageName . '.php';
			}
		}
	}
}

if(!function_exists('EX_WPTVS_query')){
    function EX_WPTVS_query($posttype, $count, $order, $orderby, $cat, $tag, $taxonomy, $meta_key, $ids, $meta_date, $meta_value=false,$page=false,$mult=false){
		$posttype = 'extvs_schedule';
		$posttype = explode(",", $posttype);
		if($ids!=''){ //specify IDs
			$ids = explode(",", $ids);
			$args = array(
				'post_type' => $posttype,
				'posts_per_page' => $count,
				'post_status' => array( 'publish', 'future' ),
				'post__in' =>  $ids,
				'order' => $order,
				'orderby' => $orderby,
				'ignore_sticky_posts' => 1,
			);
		}elseif($ids==''){
			$args = array(
				'post_type' => $posttype,
				'posts_per_page' => $count,
				'post_status' => array( 'publish', 'future' ),
				'tag' => $tag,
				'order' => $order,
				'orderby' => $orderby,
				'meta_key' => $meta_key,
				'ignore_sticky_posts' => 1,
			);
			if(!is_array($cat) && $taxonomy =='') {
				$cats = explode(",",$cat);
				if(is_numeric($cats[0])){
					$args['category__in'] = $cats;
				}else{			 
					$args['category_name'] = $cat;
				}
			}elseif( is_array($cat) && count($cat) > 0 && $taxonomy ==''){
				$args['category__in'] = $cat;
			}
			if($taxonomy !='' && $tag!=''){
				$tags = explode(",",$tag);
				if(is_numeric($tags[0])){$field_tag = 'term_id'; }
				else{ $field_tag = 'slug'; }
				if(count($tags)>1){
					  $texo = array(
						  'relation' => 'OR',
					  );
					  foreach($tags as $iterm) {
						  $texo[] = 
							  array(
								  'taxonomy' => $taxonomy,
								  'field' => $field_tag,
								  'terms' => $iterm,
							  );
					  }
				  }else{
					  $texo = array(
						  array(
								  'taxonomy' => $taxonomy,
								  'field' => $field_tag,
								  'terms' => $tags,
							  )
					  );
				}
			}
			//cats
			if($taxonomy !='' && $cat!=''){
				$cats = explode(",",$cat);
				if(is_numeric($cats[0])){$field = 'term_id'; }
				else{ $field = 'slug'; }
				if(count($cats)>1){
					  $texo = array(
						  'relation' => 'OR',
					  );
					  foreach($cats as $iterm) {
						  $texo[] = 
							  array(
								  'taxonomy' => $taxonomy,
								  'field' => $field,
								  'terms' => $iterm,
							  );
					  }
				  }else{
					  $texo = array(
						  array(
								  'taxonomy' => $taxonomy,
								  'field' => $field,
								  'terms' => $cats,
							  )
					  );
				}
			}
			if(isset($mult) && $mult!=''){
				$texo['relation'] = 'AND';
				$texo[] = 
					array(
						'taxonomy' => 'wpex_category',
						'field' => 'term_id',
						'terms' => $mult,
					);
			}
			if(isset($texo)){
				$args += array('tax_query' => $texo);
			}
		}
		if(isset($meta_value) && $meta_value!='' && $meta_key!=''){
			if(!empty($args['meta_query'])){
				$args['meta_query']['relation'] = 'AND';
			}
			$args['meta_query'][] = array(
				'key'  => $meta_key,
				'value' => $meta_value,
				'compare' => '='
			);
			if ($meta_date!='') {
				$args['meta_query'][] = array(
					'key'  => 'extvs_schedule_date',
					'value' => $meta_date,
					'compare' => '='
				);
			}
		}else{
			if ($meta_date!='') {
				$args['meta_query'][] = array(
					'key'  => 'extvs_schedule_date',
					'value' => $meta_date,
					'compare' => '='
				);
			}
		}	
		if(isset($page) && $page!=''){
			$args['paged'] = $page;
		}
		return apply_filters( 'extvs_query', $args );
	}
}

if(!function_exists('extvs_channel_select_html')){
	function extvs_channel_select_html($chanel,$style,$cats,$check=false){
		$args = array(
			'parent'        => '0',
			'hide_empty'        => false,
		);
		$chanels = $chanel!=''? explode(",",$chanel) : array();
		if (!empty($chanels) && !is_numeric($chanels[0])) {
			$args['slug'] = $chanels;
		}else if (!empty($chanels)) {
			$args['include'] = $chanels;
		}
		$terms = get_terms('extvs_channel', $args);
		if ($terms) {
			if ($check == false) {
		?>
			<div class="extvs-dropdown">
		        
		        <input type="hidden" name="gender">
		        <ul class="extvs-dropdown-chanel">
	        	<?php
	        		$select = '';
				  	foreach ( $terms as $term ) {
				  		if ($term->slug == $cats || $term->term_id == $cats) {
							$select = $term->name;
						}
				  		echo '<li data-value="'. $term->slug .'" data-display="'.$term->name.'">'. $term->name .'</option>';
				  	}
				?>
		        </ul>
		        <div class="extvs-select-chanel">
		          <span><?php echo wp_kses_post($select); ?></span>
		          <i class="extvs-arrow-down"></i>
		        </div>
			</div>
        <?php }
    	if ($style == '2') {?>
    		<div class="extvs-inline-chanel">
    			<ul>
				<?php
					foreach ( $terms as $term ) {
						$class = '';
						if ($term->slug == $cats || $term->term_id == $cats) {
							$class = ' extvs-inline-at';
						}
						
						echo '<li class="extvs-inline-select'.$class.'" data-value="'. $term->slug .'"><span>'. $term->name .'</span></li>';
					}
				?>
				</ul>
    		</div>
    	<?php }
    	if ($style == '3' && $check == true) {?>
    			<ul>
				<?php
					foreach ( $terms as $term ) {
						$class = '';
						if ($term->slug == $cats || $term->term_id == $cats) {
							$class = ' extvs-inline-at';
						}
						
						echo '<li class="extvs-inline-select'.$class.'" data-value="'. $term->slug .'"><span>'. $term->name .'</span></li>';
					}
				?>
				</ul>
    	<?php }
        ?>
        <?php }
	}
}

if(!function_exists('extvs_date_list_html')){
	function extvs_date_list_html($before_today,$after_today){
		if ($before_today < 0 || $after_today < 0) {
			return;
		}
		$list_item_dates= array();
		$cure_time =  strtotime("now");
		$gmt_offset = get_option('gmt_offset');
		if($gmt_offset!=''){
			$cure_time = $cure_time + ($gmt_offset*3600);
		}
		$date = strtotime(date('Y-m-d', $cure_time));

		for ($i = $before_today ; $i>= 1; $i -- ) {
			$date_un = strtotime("-$i day", $date);
			$show = (date_i18n('M', $date_un)).' '.date_i18n('d', $date_un);
			$list_item_dates[$date_un] = $show;
		}
		for ($i = 0 ; $i<= $after_today; $i ++ ) {
			$date_un = strtotime("+$i day", $date);
			$show = (date_i18n('M', $date_un)).' '.date_i18n('d', $date_un);
			$list_item_dates[$date_un] = $show;
		}
		foreach ($list_item_dates as $key => $value){
			$current_date = strtotime(date('Y-m-d', $cure_time));
			$current = '';
			if ($current_date== $key) {
				$current = ' extvs-date-day-at';
			}
			echo '<div class="extvs-date-day'.$current.'" data-date="'.$key.'">';
			echo '<span class="extvs-day-week">'.(date_i18n('D', $key)).'</span>';
			echo '<span class="extvs-date-value">'.$value.'</span>';
			echo "</div>";
		}
	}
}

add_action( 'wp_ajax_extvs_get_schedule_simple', 'ajax_extvs_get_schedule_simple' );
add_action( 'wp_ajax_nopriv_extvs_get_schedule_simple', 'ajax_extvs_get_schedule_simple' );

function ajax_extvs_get_schedule_simple(){
	$atts = json_decode( stripslashes( $_POST['param_shortcode'] ), true );
	global $ID, $fullcontent_in, $show_image;
	$ID = isset($atts['ID']) && $atts['ID'] !=''? $atts['ID'] : 'ex-'.rand(10,9999);
	if(!isset($atts['ID'])){
		$atts['ID']= $ID;
	}
	$posttype = 'ex_food';
	$style = isset($atts['style']) && $atts['style'] !=''? $atts['style'] : '1';
	$ids   = isset($atts['ids']) ? $atts['ids'] : '';
	$taxonomy  = isset($atts['taxonomy']) ? $atts['taxonomy'] : '';
	$chanel   = isset($atts['chanel']) ? $atts['chanel'] : '';
	$tag  = isset($atts['tag']) ? $atts['tag'] : '';
	$count   = isset($atts['count']) &&  $atts['count'] !=''? $atts['count'] : '';
	$posts_per_page   = isset($atts['posts_per_page']) && $atts['posts_per_page'] !=''? $atts['posts_per_page'] : '1';
	$order  = isset($atts['order']) ? $atts['order'] : '';
	$orderby  = isset($atts['orderby']) ? $atts['orderby'] : '';
	$meta_key  = isset($atts['meta_key']) ? $atts['meta_key'] : '';
	$meta_value  = isset($atts['meta_value']) ? $atts['meta_value'] : '';
	$fullcontent_in   = isset($atts['fullcontent_in']) ? $atts['fullcontent_in'] : 'collapse';
	$show_image   = isset($atts['show_image']) ? $atts['show_image'] : 'show';
	if ($show_image != 'show') {
		$show_image = 'non';
	}
	$class  = isset($atts['class']) ? $atts['class'] : '';
	$paged = get_query_var('paged')?get_query_var('paged'):(get_query_var('page')?get_query_var('page'):1);
	$meta_date = '';
	if(isset($_POST['date']) && $_POST['chanel']!=''){
		$date = sanitize_text_field( $_POST['date'] );
		$chanel = sanitize_text_field( $_POST['chanel'] );
		$cats = $chanel;
		$meta_date = $date;
	}else{
		return;
	}
	$args = EX_WPTVS_query($posttype, $posts_per_page, $order, $orderby, $cats, $tag, 'extvs_channel', $meta_key, $ids, $meta_date, $meta_value);
	$the_query = new WP_Query( $args );
	ob_start();
	if ($the_query->have_posts()){ 
		while ($the_query->have_posts()) { $the_query->the_post();
			$options = get_post_meta( get_the_ID(), 'extvs_schedule_addition_data', true );
			global $item_tvs;
			if(!empty($options)){
				if ($style == '1' || $style ==  '2') {?>
					<table>
						<thead>
							<tr>
								<th class="extvs-table1-image"><?php echo esc_html__('Image','tv-schedule'); ?></th>
								<th class="extvs-table1-time"><?php echo esc_html__('Time','tv-schedule'); ?></th>
								<th class="extvs-table1-programme"><?php echo esc_html__('Programme','tv-schedule'); ?></th>
							</tr>
						</thead>
						<tbody>

				<?php }
				foreach ($options as $item) {
					$item_tvs = $item;?>
					<?php extvs_template_plugin('simple-'.$style,1);?>
				<?php }
				if ($style == '1' || $style ==  '2') {?>
					</tbody></table>
				<?php }
			}
		}
		wp_reset_postdata();
	}
	

	$html = ob_get_contents();
	ob_end_clean();
	if($html==''){ $html = '<p class="ex-notice">'.esc_html__('No matching records found','tv-schedule').'</p>';}
	$output =  array('html'=> $html);
	echo str_replace('\/', '/', json_encode($output));
	exit;
}

if(!function_exists('extvs_timeline_html')){
	function extvs_timeline_html(){
		echo '<ul>';
		$time2 = strtotime(date('Y-m-d'));
		for($i = 0; $i <=48 ; $i++){
			if ($i==0) {
				$time1 = date_i18n(get_option('time_format'), $time2);
				
			}else{
				$time2 = strtotime('+30 minutes', $time2);
				$time1 = date_i18n(get_option('time_format'), $time2);
			}
			echo '<li><div class="extvs-timeline-detail">';
				echo '<div class="extvs-time-hour">'.$time1.'</div>';
				echo '<div class="extvs-timeline-vertical">';
					echo '<div class="extvs-time1"></div>';
					echo '<div class="extvs-time1"></div>';
					echo '<div class="extvs-time1"></div>';
					echo '<div class="extvs-time1"></div>';
					echo '<div class="extvs-time1"></div>';
					echo '<div class="extvs-time1"></div>';
				echo "</div>";
			echo '</li>';
		}
		echo '</ul>';
	}
}

if(!function_exists('extvs_channel_advance_list')){
	function extvs_channel_advance_list($chanels){
		$args = array(
			'parent'        => '0',
			'hide_empty'        => false,
		);
		if (!empty($chanels) && !is_numeric($chanels[0])) {
			$args['slug'] = $chanels;
		}else if (!empty($chanels)) {
			$args['include'] = $chanels;
		}
		$terms = get_terms('extvs_channel', $args);
		$list = array();
		if ($terms) {
			foreach ( $terms as $term ) {
				$list[$term->term_id] = $term->name;
			}
		}
		return $list;
	}
}

if(!function_exists('extvs_advace_program_html')){
	function extvs_advace_program_html($list_chanel){
		foreach ($list_chanel as $key => $value){
			echo '<li data-value="'.$key.'">'.$value.'</li>';
		}
	}
}

if(!function_exists('extvs_advance_list_date')){
	function extvs_advance_list_date($style,$before_today,$after_today){
		if ($style == '1') {
			$list_item_dates= array();
			$cure_time =  strtotime("now");
			$gmt_offset = get_option('gmt_offset');
			if($gmt_offset!=''){
				$cure_time = $cure_time + ($gmt_offset*3600);
			}
			$date = strtotime(date('Y-m-d', $cure_time));

			for ($i = $before_today; $i>= 1; $i -- ) {
				$date_un = strtotime("-$i day", $date);
				$show = (date_i18n('M', $date_un)).' '.date('d', $date_un);
				$list_item_dates[$date_un] = $show;
			}
			for ($i = 0 ; $i<= $after_today; $i ++ ) {
				$date_un = strtotime("+$i day", $date);
				$show = (date_i18n('M', $date_un)).' '.date('d', $date_un);
				$list_item_dates[$date_un] = $show;
			}
			echo '<div class="extvs-advance-date">';
			foreach ($list_item_dates as $key => $value){
				$current_date = strtotime(date('Y-m-d'), $cure_time);
				$current = '';
				if ($current_date== $key) {
					$current = ' extvs-addate-day-at';
				}
				echo '<div class="extvs-addate-day'.$current.'" data-date="'.$key.'">';
				echo '<span class="extvs-addate-week">'.(date_i18n('D', $key)).'</span>';
				echo '<span class="extvs-addate-value">'.$value.'</span>';
				echo "</div>";
			}
			echo '</div>';
		}
		if ($style == 2) { ?>
			<div class="ex-date-list-parent">
				<div class="extvs-prev-bt"><i class="extvs-arrow-prev"></i></div>
	        	<div class="ex-date-list-out">
					<div class="ex-date-list owl-carousel owl-theme">
						<?php extvs_date_list_html($before_today,$after_today);?>
					</div>
				</div>
				<div class="extvs-next-bt"><i class="extvs-arrow-next"></i></div>
			</div>
		<?php }
		if ($style == 3) { ?>
			<?php
				$list_item_dates= array();
				$cure_time =  strtotime("now");
				$gmt_offset = get_option('gmt_offset');
				if($gmt_offset!=''){
					$cure_time = $cure_time + ($gmt_offset*3600);
				}
				$date = strtotime(date('Y-m-d', $cure_time));
				$date_yesterday = strtotime("-1 day", $date);
				$date_tomorow = strtotime("+1 day", $date);
				$list_item_dates[$date_yesterday] = esc_html__('Yesterday','tv-schedule');
				$list_item_dates[$date] = esc_html__('Today','tv-schedule');
				$list_item_dates[$date_tomorow] = esc_html__('Tomorrow','tv-schedule');

				for ($i = 2 ; $i <= 6; $i ++ ) {
					$date_un = strtotime("+$i day", $date);
					$show = (date_i18n('l', $date_un));
					$list_item_dates[$date_un] = $show;
				}
			?>
			<div class="extvs-ad-list-week">
				<?php
				$current_date = strtotime(date('Y-m-d', $cure_time));
				$current = '';
				foreach ($list_item_dates as $key => $value){
					if ($current_date == $key) {
						$current = ' extvs-ad-list-week-ac';
					}
					echo '<div class="extvs-date-adweek'.esc_attr($current).'" data-date="'.esc_attr($key).'">'. wp_kses_post($value). '</div>';
					$current = '';
				}
				?>
			</div>
		<?php }
	}
}

add_action( 'wp_ajax_extvs_get_schedule_advance', 'ajax_extvs_get_schedule_advance' );
add_action( 'wp_ajax_nopriv_extvs_get_schedule_advance', 'ajax_extvs_get_schedule_advance' );

function ajax_extvs_get_schedule_advance(){
	$atts = json_decode( stripslashes( $_POST['param_shortcode'] ), true );
	global $ID, $fullcontent_in, $show_image;
	$ID = isset($atts['ID']) && $atts['ID'] !=''? $atts['ID'] : 'ex-'.rand(10,9999);
	if(!isset($atts['ID'])){
		$atts['ID']= $ID;
	}
	$style = isset($atts['style']) && $atts['style'] !=''? $atts['style'] : '1';
	$posttype = 'extvs_schedule';
	$ids   = isset($atts['ids']) ? $atts['ids'] : '';
	$taxonomy  = isset($atts['taxonomy']) ? $atts['taxonomy'] : '';
	$tag  = isset($atts['tag']) ? $atts['tag'] : '';
	$count   = isset($atts['count']) &&  $atts['count'] !=''? $atts['count'] : '';
	$posts_per_page   = isset($atts['posts_per_page']) && $atts['posts_per_page'] !=''? $atts['posts_per_page'] : '1';
	$order  = isset($atts['order']) ? $atts['order'] : '';
	$orderby  = isset($atts['orderby']) ? $atts['orderby'] : '';
	$meta_key  = isset($atts['meta_key']) ? $atts['meta_key'] : '';
	$meta_value  = isset($atts['meta_value']) ? $atts['meta_value'] : '';
	$slidesshow = isset($atts['slidesshow']) && $atts['slidesshow']!='' ? $atts['slidesshow'] : '7';
	if ($style == '1' && !isset($atts['slidesshow'])) {
		$slidesshow ='1';
	}
	$slidesscroll =  isset($atts['slidesscroll'])&& $atts['slidesscroll']!='' ? $atts['slidesscroll'] : '3';
	$start_on =  isset($atts['start_on'])&& $atts['start_on']!='' ? $atts['slidesscroll'] : '5';
	$infinite 		= isset($atts['infinite']) ? $atts['infinite'] : '';
	$fullcontent_in   = isset($atts['fullcontent_in']) ? $atts['fullcontent_in'] : 'tooltip';
	if($fullcontent_in=='tooltip'){ $fullcontent_in = 'collapse';}
	$show_image   = isset($atts['show_image']) ? $atts['show_image'] : 'show';
	if ($show_image != 'show') {
		$show_image = 'non';
	}
	$paged = get_query_var('paged')?get_query_var('paged'):(get_query_var('page')?get_query_var('page'):1);
	if(isset($_POST['date'])){
		$date = sanitize_text_field( $_POST['date'] );
		$meta_date = $date;
	}else{
		return;
	}
	$meta_date = $date;
	$list_chanel = extvs_channel_advance_list($chanel);
	ob_start();
	$yr = date_i18n("Y", $date); 
	$mon = date_i18n("m", $date); 
	$date = date_i18n("d", $date);
	$start = mktime(0,0,0,$mon,$date,$yr);
	$cure_time =  strtotime("now");
	$gmt_offset = get_option('gmt_offset');
	if($gmt_offset!=''){
		$cure_time = $cure_time + ($gmt_offset*3600);
	}
	$extvs_enable_rtl = extvs_get_option('extvs_enable_rtl');
	echo "<ul>";
	foreach ($list_chanel as $key => $value){
		$cats = $key;
		echo "<li>";
		$args = EX_WPTVS_query($posttype, $posts_per_page, $order, $orderby, $cats, $tag, 'extvs_channel', $meta_key, $ids,$meta_date, $meta_value);
		$the_query = new WP_Query( $args );
		global $item_tvs;
		if ($the_query->have_posts()){ 
			while ($the_query->have_posts()) { $the_query->the_post();
				$options = get_post_meta( get_the_ID(), 'extvs_schedule_addition_data', true );
				
				if(!empty($options)){
					foreach ($options as $item) {
						$item_tvs = $item;
						$time_start =$item['_time_start'];
						$time_end = $item['_time_end'];
						if ($time_start < 0 || $time_end < 0 || $time_start >= $time_end) {
							break;
						}
						$cr_pro = '';
						if(($cure_time >= $time_start) && ($cure_time <= $time_end)){
							$cr_pro = 'extvs-cr-progr';
						}
						$left = ($time_start - $start)/60;
						$left_pixel = $left * 4;
						$minutes = ($time_end - $time_start) / 60;
						if ($minutes < 0) {
							break;
						}
						$width = $minutes * 4;
						$class_add='';
						$hours_end= date('H', $time_end);
						$minutes_end = date('i', $time_end);
						if ($hours_end == 23 && $minutes_end == 59) {
							$class_add = ' extvs-pro-end';
							$width = $width + 4;
						}
						if ($extvs_enable_rtl == 'yes') {
							echo '<div class="extvs-pro-width'.esc_attr($class_add).' '.esc_attr($cr_pro).'" style="right:'.esc_attr($left_pixel).'px; width:'.esc_attr($width).'px">';
						}else{
							echo '<div class="extvs-pro-width'.esc_attr($class_add).' '.esc_attr($cr_pro).'" style="left:'.esc_attr($left_pixel).'px; width:'.esc_attr($width).'px">';
						}
						echo extvs_template_plugin('advance-1',1);

						echo '</div>';
						
					}
				}
				
			}
		}

		wp_reset_postdata();
		echo "</li>";
	}
	echo "</ul>";

	$html = ob_get_contents();
	ob_end_clean();
	$output =  array('html'=> $html);
	echo str_replace('\/', '/', json_encode($output));
	exit;
}

function extvs_image($data){
	$image = wp_get_attachment_image( $data['_image_id'], 'exsc_200x144' );
	return $image;
}