<?php
/*
Plugin Name: TV Schedule
Plugin URI: https://exthemes.net/tv-schedule/
Description: TV Schedule and timetable for WordPress
Version: 1.0
Author: Ex-Themes
Author URI: https://exthemes.net
Text Domain: tv-schedule
License: Envato Split Licence
Domain Path: /languages/
*/
define( 'EXTVS_PATH', plugin_dir_url( __FILE__ ) );
// Make sure we don't expose any info if called directly
if ( !defined('EXTVS_PATH') ){
	die('-1');
}
if(!function_exists('extvs_get_plugin_url')){
	function extvs_get_plugin_url(){
		return plugin_dir_path(__FILE__);
	}
}
class EX_WPTVS{
	public $template_url;
	public $plugin_path;
	public function __construct(){
		$this->includes();
		add_filter( 'template_include', array( $this, 'template_loader' ),99 );
		add_action('wp_enqueue_scripts', array($this, 'frontend_scripts'),99 );
		add_action('plugins_loaded',array( $this, 'load_textdomain'));
		add_action( 'after_setup_theme', array($this, 'calthumb_register') );
    }
	function load_textdomain() {
		$textdomain = 'tv-schedule';
		$locale = '';
		if ( empty( $locale ) ) {
			if ( is_textdomain_loaded( $textdomain ) ) {
				return true;
			} else {
				return load_plugin_textdomain( $textdomain, false, plugin_basename( dirname( __FILE__ ) ) . '/language' );
			}
		} else {
			return load_textdomain( $textdomain, plugin_basename( dirname( __FILE__ ) ) . '/' . $textdomain . '-' . $locale . '.mo' );
		}
	}
	//thumbnails register
	function calthumb_register(){
		add_image_size('exsc_200x144',200,144, true);
	}

	function template_loader($template){
		$find = array('archive-food.php');
		$file = '';			
		if(is_post_type_archive( 'extvs_schedule' ) || is_tax('exfood_cat') || is_tax('exfood_loc')){
			wp_redirect( get_template_part( '404' ) ); exit;
		}
		if(is_singular('extvs_schedule')){
			wp_redirect( get_template_part( '404' ) ); exit;
		}
		return $template;		
	}
	public function plugin_path() {
		if ( $this->plugin_path ) return $this->plugin_path;
		return $this->plugin_path = untrailingslashit( plugin_dir_path( __FILE__ ) );
	}
	function includes(){
		include_once extvs_get_plugin_url().'admin/functions.php';
		include_once extvs_get_plugin_url().'inc/functions.php';
	}
	// Load js and css
	function frontend_scripts(){
		wp_enqueue_script( 'extvs-js',plugins_url('/js/tvschedule.js', __FILE__) , array( 'jquery' ),'1.0' );
		$extvs_custom_js = extvs_get_option('extvs_custom_js','extvs_custom_code_options');
   		wp_add_inline_script( 'extvs-js', $extvs_custom_js );
		wp_enqueue_style( 'owl.carousel', EXTVS_PATH.'js/owl-carousel/assets/owl.carousel.css');
		wp_enqueue_style( 'owl.carousel-theme', EXTVS_PATH.'js/owl-carousel/assets/owl.theme.default.css');
		wp_enqueue_script( 'owl.carousel', EXTVS_PATH.'js/owl-carousel/owl.carousel.js', array( 'jquery' ),'1.0' );

		wp_enqueue_style('extvs-style', EXTVS_PATH.'css/style.css','1.0');
		wp_enqueue_style('extvs-style-view', EXTVS_PATH.'css/modal.css','1.0');

		require extvs_get_plugin_url(). 'css/custom.css.php';
		$ctcss = extvs_custom_css();
		$extvs_enable_rtl = extvs_get_option('extvs_enable_rtl');
		if($extvs_enable_rtl=='yes'){
			wp_enqueue_style('extvs-style-rtl', EXTVS_PATH.'css/rtl.css');
			wp_add_inline_style( 'extvs-style-rtl', $ctcss );
		}else{
			wp_add_inline_style( 'extvs-style-view', $ctcss );
		}
		
	}
}
$EX_WPTVS = new EX_WPTVS();